<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCreneau ArrayType
 * @subpackage Arrays
 */
class ArrayOfCreneau extends AbstractStructArrayBase
{
    /**
     * The Creneau
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Creneau[]
     */
    public $Creneau;
    /**
     * Constructor method for ArrayOfCreneau
     * @uses ArrayOfCreneau::setCreneau()
     * @param \StructType\Creneau[] $creneau
     */
    public function __construct(array $creneau = array())
    {
        $this
            ->setCreneau($creneau);
    }
    /**
     * Get Creneau value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Creneau[]|null
     */
    public function getCreneau()
    {
        return isset($this->Creneau) ? $this->Creneau : null;
    }
    /**
     * Set Creneau value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Creneau[] $creneau
     * @return \ArrayType\ArrayOfCreneau
     */
    public function setCreneau(array $creneau = array())
    {
        foreach ($creneau as $arrayOfCreneauCreneauItem) {
            // validation for constraint: itemType
            if (!$arrayOfCreneauCreneauItem instanceof \StructType\Creneau) {
                throw new \InvalidArgumentException(sprintf('The Creneau property can only contain items of \StructType\Creneau, "%s" given', is_object($arrayOfCreneauCreneauItem) ? get_class($arrayOfCreneauCreneauItem) : gettype($arrayOfCreneauCreneauItem)), __LINE__);
            }
        }
        if (is_null($creneau) || (is_array($creneau) && empty($creneau))) {
            unset($this->Creneau);
        } else {
            $this->Creneau = $creneau;
        }
        return $this;
    }
    /**
     * Add item to Creneau value
     * @throws \InvalidArgumentException
     * @param \StructType\Creneau $item
     * @return \ArrayType\ArrayOfCreneau
     */
    public function addToCreneau(\StructType\Creneau $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Creneau) {
            throw new \InvalidArgumentException(sprintf('The Creneau property can only contain items of \StructType\Creneau, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Creneau[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Creneau|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Creneau|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Creneau|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Creneau|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Creneau|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Creneau
     */
    public function getAttributeName()
    {
        return 'Creneau';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCreneau
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
