<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Groupes' => '\\StructType\\Groupes',
            'GroupesResponse' => '\\StructType\\GroupesResponse',
            'ReponseGroupe' => '\\StructType\\ReponseGroupe',
            'ArrayOfGroupe' => '\\ArrayType\\ArrayOfGroupe',
            'Groupe' => '\\StructType\\Groupe',
            'ArrayOfPhoto' => '\\ArrayType\\ArrayOfPhoto',
            'Photo' => '\\StructType\\Photo',
            'Centres' => '\\StructType\\Centres',
            'CentresResponse' => '\\StructType\\CentresResponse',
            'ReponseCentre' => '\\StructType\\ReponseCentre',
            'ArrayOfCentre' => '\\ArrayType\\ArrayOfCentre',
            'Centre' => '\\StructType\\Centre',
            'Description' => '\\StructType\\Description',
            'MetaDescription' => '\\StructType\\MetaDescription',
            'ArrayOfActivite' => '\\ArrayType\\ArrayOfActivite',
            'Activite' => '\\StructType\\Activite',
            'Activites' => '\\StructType\\Activites',
            'ActivitesResponse' => '\\StructType\\ActivitesResponse',
            'ReponseActivite' => '\\StructType\\ReponseActivite',
            'Prestations' => '\\StructType\\Prestations',
            'PrestationsResponse' => '\\StructType\\PrestationsResponse',
            'ReponsePrestation' => '\\StructType\\ReponsePrestation',
            'ArrayOfPrestation' => '\\ArrayType\\ArrayOfPrestation',
            'Prestation' => '\\StructType\\Prestation',
            'PrestationsCTonline' => '\\StructType\\PrestationsCTonline',
            'PrestationsCTonlineResponse' => '\\StructType\\PrestationsCTonlineResponse',
            'Options' => '\\StructType\\Options',
            'OptionsResponse' => '\\StructType\\OptionsResponse',
            'ReponseOption' => '\\StructType\\ReponseOption',
            'ArrayOfOption' => '\\ArrayType\\ArrayOfOption',
            'Option' => '\\StructType\\Option',
            'ArrayOfChoix' => '\\ArrayType\\ArrayOfChoix',
            'Choix' => '\\StructType\\Choix',
            'Planning' => '\\StructType\\Planning',
            'PlanningResponse' => '\\StructType\\PlanningResponse',
            'ReponsePlanning' => '\\StructType\\ReponsePlanning',
            'ArrayOfCreneau' => '\\ArrayType\\ArrayOfCreneau',
            'Creneau' => '\\StructType\\Creneau',
            'ArrayOfJour' => '\\ArrayType\\ArrayOfJour',
            'Jour' => '\\StructType\\Jour',
            'ArrayOfRdv' => '\\ArrayType\\ArrayOfRdv',
            'Rdv' => '\\StructType\\Rdv',
            'ArrayOfContenu' => '\\ArrayType\\ArrayOfContenu',
            'Contenu' => '\\StructType\\Contenu',
            'PlanningCTonline' => '\\StructType\\PlanningCTonline',
            'PlanningCTonlineResponse' => '\\StructType\\PlanningCTonlineResponse',
            'Coupon' => '\\StructType\\Coupon',
            'CouponResponse' => '\\StructType\\CouponResponse',
            'ReponseCoupon' => '\\StructType\\ReponseCoupon',
            'Horaires' => '\\StructType\\Horaires',
            'HorairesResponse' => '\\StructType\\HorairesResponse',
            'ReponseHoraire' => '\\StructType\\ReponseHoraire',
            'ArrayOfHoraire' => '\\ArrayType\\ArrayOfHoraire',
            'Horaire' => '\\StructType\\Horaire',
            'ArrayOfPlageHoraire' => '\\ArrayType\\ArrayOfPlageHoraire',
            'PlageHoraire' => '\\StructType\\PlageHoraire',
            'Tarifs' => '\\StructType\\Tarifs',
            'TarifsResponse' => '\\StructType\\TarifsResponse',
            'ReponseTarif' => '\\StructType\\ReponseTarif',
            'ArrayOfTarif' => '\\ArrayType\\ArrayOfTarif',
            'Tarif' => '\\StructType\\Tarif',
            'InfosRelance' => '\\StructType\\InfosRelance',
            'InfosRelanceResponse' => '\\StructType\\InfosRelanceResponse',
            'ReponseInfosRelance' => '\\StructType\\ReponseInfosRelance',
            'Unsubscribe' => '\\StructType\\Unsubscribe',
            'UnsubscribeResponse' => '\\StructType\\UnsubscribeResponse',
            'Response' => '\\StructType\\Response',
            'Tracking' => '\\StructType\\Tracking',
            'TrackingResponse' => '\\StructType\\TrackingResponse',
            'ReponseTracking' => '\\StructType\\ReponseTracking',
        );
    }
}
