<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Coupon StructType
 * @subpackage Structs
 */
class Coupon extends AbstractStructBase
{
    /**
     * The CodeGroupe
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CodeGroupe;
    /**
     * The CodeCentre
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CodeCentre;
    /**
     * The DocXml
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DocXml;
    /**
     * Constructor method for Coupon
     * @uses Coupon::setCodeGroupe()
     * @uses Coupon::setCodeCentre()
     * @uses Coupon::setDocXml()
     * @param string $codeGroupe
     * @param string $codeCentre
     * @param string $docXml
     */
    public function __construct($codeGroupe = null, $codeCentre = null, $docXml = null)
    {
        $this
            ->setCodeGroupe($codeGroupe)
            ->setCodeCentre($codeCentre)
            ->setDocXml($docXml);
    }
    /**
     * Get CodeGroupe value
     * @return string|null
     */
    public function getCodeGroupe()
    {
        return $this->CodeGroupe;
    }
    /**
     * Set CodeGroupe value
     * @param string $codeGroupe
     * @return \StructType\Coupon
     */
    public function setCodeGroupe($codeGroupe = null)
    {
        // validation for constraint: string
        if (!is_null($codeGroupe) && !is_string($codeGroupe)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codeGroupe)), __LINE__);
        }
        $this->CodeGroupe = $codeGroupe;
        return $this;
    }
    /**
     * Get CodeCentre value
     * @return string|null
     */
    public function getCodeCentre()
    {
        return $this->CodeCentre;
    }
    /**
     * Set CodeCentre value
     * @param string $codeCentre
     * @return \StructType\Coupon
     */
    public function setCodeCentre($codeCentre = null)
    {
        // validation for constraint: string
        if (!is_null($codeCentre) && !is_string($codeCentre)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codeCentre)), __LINE__);
        }
        $this->CodeCentre = $codeCentre;
        return $this;
    }
    /**
     * Get DocXml value
     * @return string|null
     */
    public function getDocXml()
    {
        return $this->DocXml;
    }
    /**
     * Set DocXml value
     * @param string $docXml
     * @return \StructType\Coupon
     */
    public function setDocXml($docXml = null)
    {
        // validation for constraint: string
        if (!is_null($docXml) && !is_string($docXml)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($docXml)), __LINE__);
        }
        $this->DocXml = $docXml;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Coupon
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
