<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Photo StructType
 * @subpackage Structs
 */
class Photo extends AbstractStructBase
{
    /**
     * The DateDerniereModif
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $DateDerniereModif;
    /**
     * The Identifiant
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Identifiant;
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * The Donnees
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Donnees;
    /**
     * The Extension
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Extension;
    /**
     * Constructor method for Photo
     * @uses Photo::setDateDerniereModif()
     * @uses Photo::setIdentifiant()
     * @uses Photo::setType()
     * @uses Photo::setDonnees()
     * @uses Photo::setExtension()
     * @param string $dateDerniereModif
     * @param string $identifiant
     * @param string $type
     * @param string $donnees
     * @param string $extension
     */
    public function __construct($dateDerniereModif = null, $identifiant = null, $type = null, $donnees = null, $extension = null)
    {
        $this
            ->setDateDerniereModif($dateDerniereModif)
            ->setIdentifiant($identifiant)
            ->setType($type)
            ->setDonnees($donnees)
            ->setExtension($extension);
    }
    /**
     * Get DateDerniereModif value
     * @return string
     */
    public function getDateDerniereModif()
    {
        return $this->DateDerniereModif;
    }
    /**
     * Set DateDerniereModif value
     * @param string $dateDerniereModif
     * @return \StructType\Photo
     */
    public function setDateDerniereModif($dateDerniereModif = null)
    {
        // validation for constraint: string
        if (!is_null($dateDerniereModif) && !is_string($dateDerniereModif)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dateDerniereModif)), __LINE__);
        }
        $this->DateDerniereModif = $dateDerniereModif;
        return $this;
    }
    /**
     * Get Identifiant value
     * @return string|null
     */
    public function getIdentifiant()
    {
        return $this->Identifiant;
    }
    /**
     * Set Identifiant value
     * @param string $identifiant
     * @return \StructType\Photo
     */
    public function setIdentifiant($identifiant = null)
    {
        // validation for constraint: string
        if (!is_null($identifiant) && !is_string($identifiant)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($identifiant)), __LINE__);
        }
        $this->Identifiant = $identifiant;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \StructType\Photo
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Donnees value
     * @return string|null
     */
    public function getDonnees()
    {
        return $this->Donnees;
    }
    /**
     * Set Donnees value
     * @param string $donnees
     * @return \StructType\Photo
     */
    public function setDonnees($donnees = null)
    {
        // validation for constraint: string
        if (!is_null($donnees) && !is_string($donnees)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($donnees)), __LINE__);
        }
        $this->Donnees = $donnees;
        return $this;
    }
    /**
     * Get Extension value
     * @return string|null
     */
    public function getExtension()
    {
        return $this->Extension;
    }
    /**
     * Set Extension value
     * @param string $extension
     * @return \StructType\Photo
     */
    public function setExtension($extension = null)
    {
        // validation for constraint: string
        if (!is_null($extension) && !is_string($extension)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($extension)), __LINE__);
        }
        $this->Extension = $extension;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Photo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
