<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PlageHoraire StructType
 * @subpackage Structs
 */
class PlageHoraire extends AbstractStructBase
{
    /**
     * The HeureDebut
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $HeureDebut;
    /**
     * The HeureFin
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $HeureFin;
    /**
     * Constructor method for PlageHoraire
     * @uses PlageHoraire::setHeureDebut()
     * @uses PlageHoraire::setHeureFin()
     * @param string $heureDebut
     * @param string $heureFin
     */
    public function __construct($heureDebut = null, $heureFin = null)
    {
        $this
            ->setHeureDebut($heureDebut)
            ->setHeureFin($heureFin);
    }
    /**
     * Get HeureDebut value
     * @return string|null
     */
    public function getHeureDebut()
    {
        return $this->HeureDebut;
    }
    /**
     * Set HeureDebut value
     * @param string $heureDebut
     * @return \StructType\PlageHoraire
     */
    public function setHeureDebut($heureDebut = null)
    {
        // validation for constraint: string
        if (!is_null($heureDebut) && !is_string($heureDebut)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($heureDebut)), __LINE__);
        }
        $this->HeureDebut = $heureDebut;
        return $this;
    }
    /**
     * Get HeureFin value
     * @return string|null
     */
    public function getHeureFin()
    {
        return $this->HeureFin;
    }
    /**
     * Set HeureFin value
     * @param string $heureFin
     * @return \StructType\PlageHoraire
     */
    public function setHeureFin($heureFin = null)
    {
        // validation for constraint: string
        if (!is_null($heureFin) && !is_string($heureFin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($heureFin)), __LINE__);
        }
        $this->HeureFin = $heureFin;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PlageHoraire
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
