<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PlanningCTonline StructType
 * @subpackage Structs
 */
class PlanningCTonline extends AbstractStructBase
{
    /**
     * The CodeGroupe
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CodeGroupe;
    /**
     * The CodeCentre
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CodeCentre;
    /**
     * The CodePrestation
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CodePrestation;
    /**
     * The DateDebut
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $DateDebut;
    /**
     * The CodePersonnel
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CodePersonnel;
    /**
     * Constructor method for PlanningCTonline
     * @uses PlanningCTonline::setCodeGroupe()
     * @uses PlanningCTonline::setCodeCentre()
     * @uses PlanningCTonline::setCodePrestation()
     * @uses PlanningCTonline::setDateDebut()
     * @uses PlanningCTonline::setCodePersonnel()
     * @param string $codeGroupe
     * @param string $codeCentre
     * @param string $codePrestation
     * @param string $dateDebut
     * @param string $codePersonnel
     */
    public function __construct($codeGroupe = null, $codeCentre = null, $codePrestation = null, $dateDebut = null, $codePersonnel = null)
    {
        $this
            ->setCodeGroupe($codeGroupe)
            ->setCodeCentre($codeCentre)
            ->setCodePrestation($codePrestation)
            ->setDateDebut($dateDebut)
            ->setCodePersonnel($codePersonnel);
    }
    /**
     * Get CodeGroupe value
     * @return string|null
     */
    public function getCodeGroupe()
    {
        return $this->CodeGroupe;
    }
    /**
     * Set CodeGroupe value
     * @param string $codeGroupe
     * @return \StructType\PlanningCTonline
     */
    public function setCodeGroupe($codeGroupe = null)
    {
        // validation for constraint: string
        if (!is_null($codeGroupe) && !is_string($codeGroupe)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codeGroupe)), __LINE__);
        }
        $this->CodeGroupe = $codeGroupe;
        return $this;
    }
    /**
     * Get CodeCentre value
     * @return string|null
     */
    public function getCodeCentre()
    {
        return $this->CodeCentre;
    }
    /**
     * Set CodeCentre value
     * @param string $codeCentre
     * @return \StructType\PlanningCTonline
     */
    public function setCodeCentre($codeCentre = null)
    {
        // validation for constraint: string
        if (!is_null($codeCentre) && !is_string($codeCentre)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codeCentre)), __LINE__);
        }
        $this->CodeCentre = $codeCentre;
        return $this;
    }
    /**
     * Get CodePrestation value
     * @return string|null
     */
    public function getCodePrestation()
    {
        return $this->CodePrestation;
    }
    /**
     * Set CodePrestation value
     * @param string $codePrestation
     * @return \StructType\PlanningCTonline
     */
    public function setCodePrestation($codePrestation = null)
    {
        // validation for constraint: string
        if (!is_null($codePrestation) && !is_string($codePrestation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codePrestation)), __LINE__);
        }
        $this->CodePrestation = $codePrestation;
        return $this;
    }
    /**
     * Get DateDebut value
     * @return string|null
     */
    public function getDateDebut()
    {
        return $this->DateDebut;
    }
    /**
     * Set DateDebut value
     * @param string $dateDebut
     * @return \StructType\PlanningCTonline
     */
    public function setDateDebut($dateDebut = null)
    {
        // validation for constraint: string
        if (!is_null($dateDebut) && !is_string($dateDebut)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dateDebut)), __LINE__);
        }
        $this->DateDebut = $dateDebut;
        return $this;
    }
    /**
     * Get CodePersonnel value
     * @return string|null
     */
    public function getCodePersonnel()
    {
        return $this->CodePersonnel;
    }
    /**
     * Set CodePersonnel value
     * @param string $codePersonnel
     * @return \StructType\PlanningCTonline
     */
    public function setCodePersonnel($codePersonnel = null)
    {
        // validation for constraint: string
        if (!is_null($codePersonnel) && !is_string($codePersonnel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codePersonnel)), __LINE__);
        }
        $this->CodePersonnel = $codePersonnel;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PlanningCTonline
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
