<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Rdv StructType
 * @subpackage Structs
 */
class Rdv extends AbstractStructBase
{
    /**
     * The CodeCreneau
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CodeCreneau;
    /**
     * The Libelle
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Libelle;
    /**
     * The PrixPromo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $PrixPromo;
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * The Style
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Style;
    /**
     * The ListeContenu
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfContenu
     */
    public $ListeContenu;
    /**
     * Constructor method for Rdv
     * @uses Rdv::setCodeCreneau()
     * @uses Rdv::setLibelle()
     * @uses Rdv::setPrixPromo()
     * @uses Rdv::setType()
     * @uses Rdv::setStyle()
     * @uses Rdv::setListeContenu()
     * @param string $codeCreneau
     * @param string $libelle
     * @param string $prixPromo
     * @param string $type
     * @param string $style
     * @param \ArrayType\ArrayOfContenu $listeContenu
     */
    public function __construct($codeCreneau = null, $libelle = null, $prixPromo = null, $type = null, $style = null, \ArrayType\ArrayOfContenu $listeContenu = null)
    {
        $this
            ->setCodeCreneau($codeCreneau)
            ->setLibelle($libelle)
            ->setPrixPromo($prixPromo)
            ->setType($type)
            ->setStyle($style)
            ->setListeContenu($listeContenu);
    }
    /**
     * Get CodeCreneau value
     * @return string|null
     */
    public function getCodeCreneau()
    {
        return $this->CodeCreneau;
    }
    /**
     * Set CodeCreneau value
     * @param string $codeCreneau
     * @return \StructType\Rdv
     */
    public function setCodeCreneau($codeCreneau = null)
    {
        // validation for constraint: string
        if (!is_null($codeCreneau) && !is_string($codeCreneau)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codeCreneau)), __LINE__);
        }
        $this->CodeCreneau = $codeCreneau;
        return $this;
    }
    /**
     * Get Libelle value
     * @return string|null
     */
    public function getLibelle()
    {
        return $this->Libelle;
    }
    /**
     * Set Libelle value
     * @param string $libelle
     * @return \StructType\Rdv
     */
    public function setLibelle($libelle = null)
    {
        // validation for constraint: string
        if (!is_null($libelle) && !is_string($libelle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($libelle)), __LINE__);
        }
        $this->Libelle = $libelle;
        return $this;
    }
    /**
     * Get PrixPromo value
     * @return string|null
     */
    public function getPrixPromo()
    {
        return $this->PrixPromo;
    }
    /**
     * Set PrixPromo value
     * @param string $prixPromo
     * @return \StructType\Rdv
     */
    public function setPrixPromo($prixPromo = null)
    {
        // validation for constraint: string
        if (!is_null($prixPromo) && !is_string($prixPromo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($prixPromo)), __LINE__);
        }
        $this->PrixPromo = $prixPromo;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \StructType\Rdv
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Style value
     * @return string|null
     */
    public function getStyle()
    {
        return $this->Style;
    }
    /**
     * Set Style value
     * @param string $style
     * @return \StructType\Rdv
     */
    public function setStyle($style = null)
    {
        // validation for constraint: string
        if (!is_null($style) && !is_string($style)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($style)), __LINE__);
        }
        $this->Style = $style;
        return $this;
    }
    /**
     * Get ListeContenu value
     * @return \ArrayType\ArrayOfContenu|null
     */
    public function getListeContenu()
    {
        return $this->ListeContenu;
    }
    /**
     * Set ListeContenu value
     * @param \ArrayType\ArrayOfContenu $listeContenu
     * @return \StructType\Rdv
     */
    public function setListeContenu(\ArrayType\ArrayOfContenu $listeContenu = null)
    {
        $this->ListeContenu = $listeContenu;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Rdv
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
