<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Tarifs StructType
 * @subpackage Structs
 */
class Tarifs extends AbstractStructBase
{
    /**
     * The CodeGroupe
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CodeGroupe;
    /**
     * The CodeCentre
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CodeCentre;
    /**
     * The CodePersonnel
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CodePersonnel;
    /**
     * Constructor method for Tarifs
     * @uses Tarifs::setCodeGroupe()
     * @uses Tarifs::setCodeCentre()
     * @uses Tarifs::setCodePersonnel()
     * @param string $codeGroupe
     * @param string $codeCentre
     * @param string $codePersonnel
     */
    public function __construct($codeGroupe = null, $codeCentre = null, $codePersonnel = null)
    {
        $this
            ->setCodeGroupe($codeGroupe)
            ->setCodeCentre($codeCentre)
            ->setCodePersonnel($codePersonnel);
    }
    /**
     * Get CodeGroupe value
     * @return string|null
     */
    public function getCodeGroupe()
    {
        return $this->CodeGroupe;
    }
    /**
     * Set CodeGroupe value
     * @param string $codeGroupe
     * @return \StructType\Tarifs
     */
    public function setCodeGroupe($codeGroupe = null)
    {
        // validation for constraint: string
        if (!is_null($codeGroupe) && !is_string($codeGroupe)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codeGroupe)), __LINE__);
        }
        $this->CodeGroupe = $codeGroupe;
        return $this;
    }
    /**
     * Get CodeCentre value
     * @return string|null
     */
    public function getCodeCentre()
    {
        return $this->CodeCentre;
    }
    /**
     * Set CodeCentre value
     * @param string $codeCentre
     * @return \StructType\Tarifs
     */
    public function setCodeCentre($codeCentre = null)
    {
        // validation for constraint: string
        if (!is_null($codeCentre) && !is_string($codeCentre)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codeCentre)), __LINE__);
        }
        $this->CodeCentre = $codeCentre;
        return $this;
    }
    /**
     * Get CodePersonnel value
     * @return string|null
     */
    public function getCodePersonnel()
    {
        return $this->CodePersonnel;
    }
    /**
     * Set CodePersonnel value
     * @param string $codePersonnel
     * @return \StructType\Tarifs
     */
    public function setCodePersonnel($codePersonnel = null)
    {
        // validation for constraint: string
        if (!is_null($codePersonnel) && !is_string($codePersonnel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codePersonnel)), __LINE__);
        }
        $this->CodePersonnel = $codePersonnel;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Tarifs
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
